﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class GameController : MonoBehaviour {

    public GameObject wave0;
    public GameObject wave1;
    public GameObject wave2;
    public Camera camera;
    private GameObject outputWave;
    public AudioClip enviriomentS;
    public AudioClip[] w0sounds;
    public AudioClip[] w1sounds;
    public AudioClip[] w2sounds;
    private AudioClip outputSound;

    public void ChangeMusic()
    {
        camera.GetComponent<AudioSource>().clip = enviriomentS;
    }

    public void CreateWave(Transform origin, string waveType, bool directionRight)
    {
        int number = Random.Range(0, w0sounds.Length);
        switch (waveType)
        {
            case "Sinusoidal":
                outputWave = wave0;
                outputSound = w0sounds[number];
                break;
            case "Cubic":
                outputWave = wave1;
                outputSound = w1sounds[number];
                break;
            case "Triangular":
                outputWave = wave2;
                outputSound = w2sounds[number];
                break;
            default:
                print("Incorrect waveType");
                break;
        }

        GameObject wave;
        if (!directionRight)
        {
            wave = Instantiate(outputWave, origin.position + new Vector3(0.5f, 0f, 0f), transform.rotation);
            wave.GetComponent<WaveMovement>().directionX = true;
            wave.GetComponent<AudioSource>().PlayOneShot(outputSound);

        }
        else
        {
            wave = Instantiate(outputWave, origin.position - new Vector3(0.5f, 0f, 0f), transform.rotation);
            wave.GetComponent<WaveMovement>().directionX = false ;
            wave.GetComponent<AudioSource>().PlayOneShot(outputSound);
        }
        
    }

	public void CreateCollisionWave(Transform wave1, Transform wave2, string waveType, bool directionRight)
	{
		GameObject wave;
		wave = Instantiate(outputWave, (wave1.position+wave2.position)/2 + new Vector3(0f, 0f, 0f), transform.rotation);
		wave.GetComponent<WaveMovement>().directionX = true;
		wave.GetComponent<AudioSource>().PlayOneShot(outputSound);
		wave.GetComponent<Collider2D> ().enabled =false;
		wave.transform.localScale = new Vector3(wave1.localScale.x+wave2.localScale.x, wave1.localScale.y+wave2.localScale.y, wave1.localScale.z+wave2.localScale.z);
		StartCoroutine (DestroyInSeconds (0.5f, wave));

	}

	IEnumerator DestroyInSeconds(float duration, GameObject gameObject)
	{
		yield return new WaitForSeconds(duration);
		DestroyObject (gameObject);
	}
}
